#!/perl/bin
# -----------------------------------------------------------------------------
# SCANMAC v1.1 for NT4             1998 Nils Reichen <prog.reichen@worldcom.ch>
# -----------------------------------------------------------------------------
# This program does a scan of all the connecting computer every $time_out
# sec., default value is 900 sec. = 15 min.
# It return the MAC and IP address and if possible the DNS and NetBIOS 
# name.
#
# Made by Nils Reichen <prog.reichen@worldcom.ch>
# EICN, NEUCHATEL SCHOOL OF ENGINEERING
# Le Locle, Switzerland
# http://home.worldcom.ch/nreichen/getmac.html
#
# under Perl 5.004_02 for WinNT4.0
# Copyri... ah hell, just take it.
# Modify and use as you see fit, but please leave my name and the EICN 
# name on it as long as it still resembles the original code.
#
# For runing this under a Unix like: change [ping -n 1] by [ping -c 1]
# and change the ipconfig cmd to the ifconfig cmd with a little change
#
#$Header: scanmac.pl,v 1.1 1998/12/30
# -----------------------------------------------------------------------------
# v1.0 Created: 18.Jun.98 - Created by Nils Reichen <prog.reichen@worldcom.ch>
# V1.1 Updated: 30.Dec.98 - Some little change
$ver      = "v1.1";
$ver_date = "30.Dec.98";
# -----------------------------------------------------------------------------

# Input file: scan.dat
# Output file: scan.log

my $time_out=900; # wait time

while(1){
    open(SCAN,"<scan.dat")|| die "Cannot open scan.dat: $!";
    open(FILE,">>scan.log") || die "Cannot open scan.log: $!";
    while(<SCAN>){
	if($_=~ /^\d{1,3}\D\d{1,3}\D\d{1,3}\D\d{1,3}/){
	    ($ipaddress)=($_=~ /^(\d{1,3}\D\d{1,3}\D\d{1,3}\D\d{1,3})/);
	    $ping=`ping -n 1 $ipaddress`;
	    if($ping=~ /bytes=/){
		$arp=`arp -a $ipaddress`;
		# filtre l'adr. MAC
		$arp=~ /\s\s\S+\s+(..-..-..-..-..-..)/;    
		$macaddr=$1;
		if($macaddr ne ""){   # if ipaddress is on localhost => skip
		    # DNS Request for $ipaddress
		    $dns=`nslookup -view $ipaddress`;
		    if ($dns=~ /Name/){
			($dns)=($dns=~ /.+\n.+\n.*\nName.\s\s\s\s(\S+)/);
		    }
		    else{ $dns="";} # if no DNS entry, $dns="";
		    # NetBIOS name search (WINS)
		    $nb=`tracert $ipaddress`;
		    ($nb)=($nb=~ /ms\s\s(\S+)\s.\d+\D\d+\D\d+\D\d+./);
		    # Writting MAC IP DNS in scan.log file
		    print FILE "MAC:$macaddr IP:$ipaddress DNS:$dns WINS:$nb\n";
		    print "DNS :         ",$dns,"\n";
		    print "NetBIOS name: ",$nb,"\n";
		    print "Address IP:   ",$ipaddress,"\n";
		    print "Address MAC:  ",$macaddr,"\n\n";		
		}
	    }
	}
    }
    close(SCAN);
    close(FILE);
    sleep($time_out);
}

###############################################################################
#
# End of scanmac.pl
#









